DS Server

POST /documentprocessing/pdf/create

Endpoint

POST https://example.com/documentprocessing/pdf/create

Description

Creates a PDF document from an input document.

Examples

The following example creates a new PDF document from a document in the internal format.

# Request:
curl --location --request POST 'https://trial.dsserver.io/documentprocessing/pdf/create?returnFormat=PDF' \
    --header 'Content-Type: application/json' \
    --header 'Authorization: Bearer fePFHv8OtIyRSCAdOnn7USc9kKdYB2rg' \
    --data-raw '{
        "documentData": "eAUBAA4AAAAAAAAAAA[..]="
    }'

# Result:
"JVBERi0xLjQNJ[..]"

Authorization

This endpoint supports the OAuth authorization method. DS Server checks the access token only when OAuth is enabled in the admin portal (see Enable OAuth). With OAuth disabled, the default of a new installation, the endpoint accepts requests without a token.

DS Server implements OAuth as the authorization method. Two flows are supported:

  • Authorization Code
  • Client Credentials

To use the Client Credentials flow, switch on Allow “Client Credentials” grant type in the security profile (see OAuth Grant Types).

In both cases, a valid access token returned from the OAuth endpoints must be passed in a Bearer Authorization Header, as a Query Parameter or in a Cookie.

Authorization Header

Header fieldDescription
AuthorizationA Bearer authorization header (also called token authentication) contains the OAuth access token. The authorization method and a space i.e. "Bearer " is then put before your valid access token. For example: Authorization: Bearer 4796E23054E64BC773CACBCAF24AD179DE9A3

Query Parameter

Query parameterDescription
access_tokenThe access token is passed directly in the endpoint URL as a query string. For example: ?access_token=4796E23054E64BC773CACBCAF24AD179DE9A3

Cookie

CookieDescription
access_tokenThe access token is passed in a cookie named access_token. For example: Cookie: access_token=4796E23054E64BC773CACBCAF24AD179DE9A3

Request Parameters

NameTypeValueOptional
returnFormatStringA string that specifies the format of the created document. Possible values are: "PDF" and "PDFA" (PDF/A-3b). Default value is "PDF".yes

Request Payload

TypeValue
PDFCreationSettingsThe PDFCreationSettings object contains the settings for the requested PDF document.

PDFCreationSettings

NameTypeValueOptional
documentKeywordsString[]String array that contains keywords that will be added to the PDF document meta information.yes
documentLevelJavaScriptActionsString[]String array that contains JavaScript actions that are embedded in the PDF.yes
imageCompressionQualityIntegerSpecifies the compression quality of images, a value between 1 and 100.yes
masterPasswordStringSpecifies the password for the document's access permissions.yes
digitalSignatureDigitalSignatureSpecifies the digital signature that is used to sign the document.yes
embeddedFilesEmbeddedFile[]Specifies an array of embedded files that are embedded into the document.yes
documentAccessPermissionsDocumentAccessPermissions (Number)Specifies access permissions for the document as the sum of the values below. It has an effect only if masterPassword is set. A name such as "AllowAll" is refused with 400.yes
documentDataStringDocument that will be converted to PDF encoded as Base64 string.no
authorStringSets the document's author.yes
creationDateDateTime (String)Sets the document's creation date which will be saved in the document.yes
lastModificationDateDateTime (String)Sets the date the document is last modified.yes
creatorApplicationStringSets the application, which has created the document.yes
documentSubjectStringSets the document's subject string which will be saved in the document. PDF limitation: The length is limited to 2000 characters.yes
documentTitleStringSets the document's title that will be saved in the document. PDF limitation: The length is limited to 2000 characters.yes
userPasswordStringSpecifies the password for the user to open the document.yes

DigitalSignature

NameTypeValueOptional
x509Certificate2StringThe X.509 certificate encoded as a Base64 string.no
passwordStringThe password of the certificate.no
timeServerURLStringThe URL of a time server.yes

EmbeddedFile

NameTypeValueOptional
creationDateDateTime (String)Specifies the date of the creation.yes
dataStringSpecifies the data of the embedded file.yes
dataTypeStringSpecifies the type of the data.yes
descriptionStringSpecifies the description of the embedded file.yes
fileNameStringSpecifies the file name of the embedded file.yes
lastModificationDateDateTime (String)Specifies the last modification date.yes
mimeTypeStringSpecifies the MIME type of the embedded file (for example: "application/pdf").yes
relationshipStringSpecifies the relationship string of the embedded file.yes
metadataStringSpecifies meta data for the embedded file.yes

DocumentAccessPermissions

NameTypeValueOptional
None = 0EnumAllows none of the possible permissions.yes
AllowAuthoring = 1EnumAllows authoring comments and fill in interactive form fields (including signature fields).yes
AllowAuthoringFields = 2EnumFill-in existing interactive form fields (including signature fields) is allowed.yes
AllowContentAccessibility = 4EnumAllows content access for the visually impaired only.yes
AllowDocumentAssembly = 8EnumAllows to assemble the document (insert, rotate or delete pages and create bookmarks or thumbnails).yes
AllowExtractContents = 16EnumCopying or otherwise extracting text and/or graphics is allowed.yes
AllowGeneralEditing = 32EnumAllows modifying the document's contents.yes
AllowHighLevelPrinting = 64EnumPrinting the document is fully allowed.yes
AllowLowLevelPrinting = 128EnumPrinting the document is allowed (low-level).yes
AllowAll = 255EnumAllows all of the possible permissions.yes

Success Response

StatusDescription
200On success, the HTTP status code in the response header is 200 (OK). The response body contains the resulting document encoded as a Base64 encoded string.

Error Response

StatusDescription
401A 401 (Unauthorized) with an empty body is returned, if OAuth is enabled and the request has no valid access token.
400A 400 (Bad Request) is returned, if the body can't be read as a PDFCreationSettings object. The body is a problem details object (application/json) with the title "One or more validation errors occurred." and the message per field in errors. This check comes before the license check.
415A 415 (Unsupported Media Type) is returned, if the Content-Type header of a request with a body is not application/json.
405A 405 (Method Not Allowed) with an empty body and the header Allow: POST is returned for any other HTTP method, for example GET.
400A 400 (Bad Request) is returned, if DS Server is not licensed or the license is invalid. On a server that is not registered, the body is the JSON string "DS Server is not registered." (application/json). DS Server checks the license before the parameter values, but after it has read the body and the typed query parameters.
400A 400 (Bad Request) is returned, if no data is found in the PDFCreationSettings object.
400A 400 (Bad Request) is returned, if no documents were found in the PDFCreationSettings object.
400A 400 (Bad Request) is returned, if the uploaded document is not valid.